Unit de08e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE21_p;

procedure de08e(F :Proc_FE_DE; M :Integer; var JSTART :Integer;
                HMIN :Extended; EPS :Extended; P :Extended;
                var YX :Array of Extended; var X :Extended; var H :Extended;
                var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var R1 :Array of Extended;
                var R2 :Array of Extended; var R3 :Array of Extended;
                var IERR :Integer);

implementation

procedure de08e(F :Proc_FE_DE; M :Integer; var JSTART :Integer;
                HMIN :Extended; EPS :Extended; P :Extended;
                var YX :Array of Extended; var X :Extended; var H :Extended;
                var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var R1 :Array of Extended;
                var R2 :Array of Extended; var R3 :Array of Extended;
                var IERR :Integer);
var
I :Integer;
EPS1,XT :Extended;
BULD,BULHM,BULT :Boolean;
C :Array [0..19] of Extended;
const
CDS :Extended = 32.0e0;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220;
begin
{   DATA  FORTRAN  }
C[0] := 0.5e0;
C[1] := 0.66666666666666666667e0;
C[2] := 0.2e0;
C[3] := 0.25e0;
C[4] := 2.0e0;
C[5] := 0.25925925925925925926e0;
C[6] := 0.37037037037037037037e0;
C[7] := 0.03703703703703703703e0;
C[8] := 0.0448e0;
C[9] := -0.2e0;
C[10] := 0.8736e0;
C[11] := 0.0864e0;
C[12] := -0.6048e0;
C[13] := -0.125e0;
C[14] := -0.66666666666666666667e0;
C[15] := -0.0625e0;
C[16] := 0.48214285714285714286e0;
C[17] := 0.37202380952380952381e0;
C[18] := 0.041666666666666666667e0;
C[19] := 0.10416666666666666667e0;
IERR := 0;
EPS1 := EPS/CDS;
if ( JSTART <>  -1 ) 
 then goto _20;
X := XP;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_10:
 end;
_20:
BULT := True;
BULHM := False;
_30:
BULD := True;
F(X,YX,R2,M);
for I:=1 to M do
 begin
  R1[(I-1)+0*M] := H*R2[I-1];
_40:
 end;
for I:=1 to M do
 begin
  R3[I-1] := YX[I-1] + R1[(I-1)+0*M]*C[0];
_50:
 end;
XT := X + H*C[0];
F(XT,R3,R2,M);
for I:=1 to M do
 begin
  R1[(I-1)+1*M] := H*R2[I-1];
_60:
 end;
for I:=1 to M do
 begin
  R3[I-1] := YX[I-1] + (R1[(I-1)+0*M] + R1[(I-1)+1*M])*C[3];
_70:
 end;
F(XT,R3,R2,M);
for I:=1 to M do
 begin
  R1[(I-1)+2*M] := H*R2[I-1];
_80:
 end;
for I:=1 to M do
 begin
  R3[I-1] := YX[I-1] - R1[(I-1)+1*M] + R1[(I-1)+2*M]*C[4];
_90:
 end;
XT := X + H;
F(XT,R3,R2,M);
for I:=1 to M do
 begin
  R1[(I-1)+3*M] := H*R2[I-1];
_100:
 end;
for I:=1 to M do
 begin
  R3[I-1] := YX[I-1] + R1[(I-1)+0*M]*C[5] + R1[(I-1)+1*M]*C[6] + R1[(I-1)+3*M]*C[7];
_110:
 end;
XT := X + H*C[1];
F(XT,R3,R2,M);
for I:=1 to M do
 begin
  R1[(I-1)+4*M] := H*R2[I-1];
_120:
 end;
for I:=1 to M do
 begin
  R3[I-1] := YX[I-1] + R1[(I-1)+0*M]*C[8] + R1[(I-1)+1*M]*C[9] + R1[(I-1)+2*M]*
    C[10] + R1[(I-1)+3*M]*C[11] + R1[(I-1)+4*M]*C[12];
_130:
 end;
XT := X + H*C[2];
F(XT,R3,R2,M);
for I:=1 to M do
 begin
  R1[(I-1)+1*M] := H*R2[I-1];
_140:
 end;
for I:=1 to M do
 begin
  XT := R1[(I-1)+0*M]*C[13] + R1[(I-1)+2*M]*C[14] + R1[(I-1)+3*M]*C[15] +
    R1[(I-1)+4*M]*C[16] + R1[(I-1)+1*M]*C[17];
  R3[I-1] := XT;
  R2[I-1] := YX[I-1] + R1[(I-1)+0*M]*C[18] + R1[(I-1)+3*M]*C[19] + R1[(I-1)+4*M]*
    C[16] + R1[(I-1)+1*M]*C[17];
  if ( Abs(R2[I-1]) >=  P ) 
   then XT := XT/R2[I-1];
  if ( Abs(XT) >=  EPS ) 
   then goto _170;
  if ( BULT ) 
   then goto _150;
  BULD := False;
  goto _160;
_150:
  if ( Abs(XT) >  EPS1 ) 
   then BULD := False;
_160:
 end;
goto _180;
_170:
if ( BULHM ) 
 then goto _210;
H := H*C[0];
BUL := False;
BULT := False;
if ( Abs(H) >  Abs(HMIN) ) 
 then goto _30;
H := Sign(HMIN,H);
BULHM := True;
goto _30;
_180:
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_190:
 end;
XP := X;
X := X + H;
for I:=1 to M do
 begin
  YX[I-1] := R2[I-1];
_200:
 end;
if ( BULD ) 
 then H := H*2.e0;
goto _220;
_210:
IERR := 65;
UTDE21(IERR,8);
_220:
JSTART := 1;
end;

end.
